git-rebase.shon commit Merge branch 'rg/no-gecos-in-pwent' (8784e4d)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6USAGE='[--interactive | -i] [-v] [--force-rebase | -f] [--no-ff] [--onto <newbase>] [<upstream>|--root] [<branch>] [--quiet | -q]'
   7LONG_USAGE='git-rebase replaces <branch> with a new branch of the
   8same name.  When the --onto option is provided the new branch starts
   9out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
  10It then attempts to create a new commit for each commit from the original
  11<branch> that does not exist in the <upstream> branch.
  12
  13It is possible that a merge failure will prevent this process from being
  14completely automatic.  You will have to resolve any such merge failure
  15and run git rebase --continue.  Another option is to bypass the commit
  16that caused the merge failure with git rebase --skip.  To restore the
  17original <branch> and remove the .git/rebase-apply working files, use the
  18command git rebase --abort instead.
  19
  20Note that if <branch> is not specified on the command line, the
  21currently checked out branch is used.
  22
  23Example:       git-rebase master~1 topic
  24
  25        A---B---C topic                   A'\''--B'\''--C'\'' topic
  26       /                   -->           /
  27  D---E---F---G master          D---E---F---G master
  28'
  29
  30SUBDIRECTORY_OK=Yes
  31OPTIONS_KEEPDASHDASH=
  32OPTIONS_SPEC="\
  33git rebase [-i] [options] [--onto <newbase>] [<upstream>] [<branch>]
  34git rebase [-i] [options] --onto <newbase> --root [<branch>]
  35git-rebase [-i] --continue | --abort | --skip
  36--
  37 Available options are
  38v,verbose!         display a diffstat of what changed upstream
  39q,quiet!           be quiet. implies --no-stat
  40onto=!             rebase onto given branch instead of upstream
  41p,preserve-merges! try to recreate merges instead of ignoring them
  42s,strategy=!       use the given merge strategy
  43no-ff!             cherry-pick all commits, even if unchanged
  44m,merge!           use merging strategies to rebase
  45i,interactive!     let the user edit the list of commits to rebase
  46f,force-rebase!    force rebase even if branch is up to date
  47X,strategy-option=! pass the argument through to the merge strategy
  48stat!              display a diffstat of what changed upstream
  49n,no-stat!         do not show diffstat of what changed upstream
  50verify             allow pre-rebase hook to run
  51rerere-autoupdate  allow rerere to update index with resolved conflicts
  52root!              rebase all reachable commits up to the root(s)
  53autosquash         move commits that begin with squash!/fixup! under -i
  54committer-date-is-author-date! passed to 'git am'
  55ignore-date!       passed to 'git am'
  56whitespace=!       passed to 'git apply'
  57ignore-whitespace! passed to 'git apply'
  58C=!                passed to 'git apply'
  59 Actions:
  60continue!          continue rebasing process
  61abort!             abort rebasing process and restore original branch
  62skip!              skip current patch and continue rebasing process
  63"
  64. git-sh-setup
  65set_reflog_action rebase
  66require_work_tree
  67cd_to_toplevel
  68
  69LF='
  70'
  71ok_to_skip_pre_rebase=
  72resolvemsg="
  73When you have resolved this problem run \"git rebase --continue\".
  74If you would prefer to skip this patch, instead run \"git rebase --skip\".
  75To restore the original branch and stop rebasing run \"git rebase --abort\".
  76"
  77unset onto
  78strategy=
  79strategy_opts=
  80do_merge=
  81merge_dir="$GIT_DIR"/rebase-merge
  82apply_dir="$GIT_DIR"/rebase-apply
  83verbose=
  84diffstat=
  85test "$(git config --bool rebase.stat)" = true && diffstat=t
  86git_am_opt=
  87rebase_root=
  88force_rebase=
  89allow_rerere_autoupdate=
  90# Non-empty if a rebase was in progress when 'git rebase' was invoked
  91in_progress=
  92# One of {am, merge, interactive}
  93type=
  94# One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
  95state_dir=
  96# One of {'', continue, skip, abort}, as parsed from command line
  97action=
  98preserve_merges=
  99autosquash=
 100test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
 101
 102read_basic_state () {
 103        head_name=$(cat "$state_dir"/head-name) &&
 104        onto=$(cat "$state_dir"/onto) &&
 105        # We always write to orig-head, but interactive rebase used to write to
 106        # head. Fall back to reading from head to cover for the case that the
 107        # user upgraded git with an ongoing interactive rebase.
 108        if test -f "$state_dir"/orig-head
 109        then
 110                orig_head=$(cat "$state_dir"/orig-head)
 111        else
 112                orig_head=$(cat "$state_dir"/head)
 113        fi &&
 114        GIT_QUIET=$(cat "$state_dir"/quiet) &&
 115        test -f "$state_dir"/verbose && verbose=t
 116        test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
 117        test -f "$state_dir"/strategy_opts &&
 118                strategy_opts="$(cat "$state_dir"/strategy_opts)"
 119        test -f "$state_dir"/allow_rerere_autoupdate &&
 120                allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
 121}
 122
 123write_basic_state () {
 124        echo "$head_name" > "$state_dir"/head-name &&
 125        echo "$onto" > "$state_dir"/onto &&
 126        echo "$orig_head" > "$state_dir"/orig-head &&
 127        echo "$GIT_QUIET" > "$state_dir"/quiet &&
 128        test t = "$verbose" && : > "$state_dir"/verbose
 129        test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
 130        test -n "$strategy_opts" && echo "$strategy_opts" > \
 131                "$state_dir"/strategy_opts
 132        test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
 133                "$state_dir"/allow_rerere_autoupdate
 134}
 135
 136output () {
 137        case "$verbose" in
 138        '')
 139                output=$("$@" 2>&1 )
 140                status=$?
 141                test $status != 0 && printf "%s\n" "$output"
 142                return $status
 143                ;;
 144        *)
 145                "$@"
 146                ;;
 147        esac
 148}
 149
 150move_to_original_branch () {
 151        case "$head_name" in
 152        refs/*)
 153                message="rebase finished: $head_name onto $onto"
 154                git update-ref -m "$message" \
 155                        $head_name $(git rev-parse HEAD) $orig_head &&
 156                git symbolic-ref HEAD $head_name ||
 157                die "Could not move back to $head_name"
 158                ;;
 159        esac
 160}
 161
 162run_specific_rebase () {
 163        if [ "$interactive_rebase" = implied ]; then
 164                GIT_EDITOR=:
 165                export GIT_EDITOR
 166        fi
 167        . git-rebase--$type
 168}
 169
 170run_pre_rebase_hook () {
 171        if test -z "$ok_to_skip_pre_rebase" &&
 172           test -x "$GIT_DIR/hooks/pre-rebase"
 173        then
 174                "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
 175                die "The pre-rebase hook refused to rebase."
 176        fi
 177}
 178
 179test -f "$apply_dir"/applying &&
 180        die 'It looks like git-am is in progress. Cannot rebase.'
 181
 182if test -d "$apply_dir"
 183then
 184        type=am
 185        state_dir="$apply_dir"
 186elif test -d "$merge_dir"
 187then
 188        if test -f "$merge_dir"/interactive
 189        then
 190                type=interactive
 191                interactive_rebase=explicit
 192        else
 193                type=merge
 194        fi
 195        state_dir="$merge_dir"
 196fi
 197test -n "$type" && in_progress=t
 198
 199total_argc=$#
 200while test $# != 0
 201do
 202        case "$1" in
 203        --no-verify)
 204                ok_to_skip_pre_rebase=yes
 205                ;;
 206        --verify)
 207                ok_to_skip_pre_rebase=
 208                ;;
 209        --continue|--skip|--abort)
 210                test $total_argc -eq 2 || usage
 211                action=${1##--}
 212                ;;
 213        --onto)
 214                test 2 -le "$#" || usage
 215                onto="$2"
 216                shift
 217                ;;
 218        -i)
 219                interactive_rebase=explicit
 220                ;;
 221        -p)
 222                preserve_merges=t
 223                test -z "$interactive_rebase" && interactive_rebase=implied
 224                ;;
 225        --autosquash)
 226                autosquash=t
 227                ;;
 228        --no-autosquash)
 229                autosquash=
 230                ;;
 231        -M|-m)
 232                do_merge=t
 233                ;;
 234        -X)
 235                shift
 236                strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--$1")"
 237                do_merge=t
 238                test -z "$strategy" && strategy=recursive
 239                ;;
 240        -s)
 241                shift
 242                strategy="$1"
 243                do_merge=t
 244                ;;
 245        -n)
 246                diffstat=
 247                ;;
 248        --stat)
 249                diffstat=t
 250                ;;
 251        -v)
 252                verbose=t
 253                diffstat=t
 254                GIT_QUIET=
 255                ;;
 256        -q)
 257                GIT_QUIET=t
 258                git_am_opt="$git_am_opt -q"
 259                verbose=
 260                diffstat=
 261                ;;
 262        --whitespace)
 263                shift
 264                git_am_opt="$git_am_opt --whitespace=$1"
 265                case "$1" in
 266                fix|strip)
 267                        force_rebase=t
 268                        ;;
 269                esac
 270                ;;
 271        --ignore-whitespace)
 272                git_am_opt="$git_am_opt $1"
 273                ;;
 274        --committer-date-is-author-date|--ignore-date)
 275                git_am_opt="$git_am_opt $1"
 276                force_rebase=t
 277                ;;
 278        -C)
 279                shift
 280                git_am_opt="$git_am_opt -C$1"
 281                ;;
 282        --root)
 283                rebase_root=t
 284                ;;
 285        -f|--no-ff)
 286                force_rebase=t
 287                ;;
 288        --rerere-autoupdate|--no-rerere-autoupdate)
 289                allow_rerere_autoupdate="$1"
 290                ;;
 291        --)
 292                shift
 293                break
 294                ;;
 295        esac
 296        shift
 297done
 298test $# -gt 2 && usage
 299
 300if test -n "$action"
 301then
 302        test -z "$in_progress" && die "No rebase in progress?"
 303        # Only interactive rebase uses detailed reflog messages
 304        if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
 305        then
 306                GIT_REFLOG_ACTION="rebase -i ($action)"
 307                export GIT_REFLOG_ACTION
 308        fi
 309fi
 310
 311case "$action" in
 312continue)
 313        # Sanity check
 314        git rev-parse --verify HEAD >/dev/null ||
 315                die "Cannot read HEAD"
 316        git update-index --ignore-submodules --refresh &&
 317        git diff-files --quiet --ignore-submodules || {
 318                echo "You must edit all merge conflicts and then"
 319                echo "mark them as resolved using git add"
 320                exit 1
 321        }
 322        read_basic_state
 323        run_specific_rebase
 324        ;;
 325skip)
 326        output git reset --hard HEAD || exit $?
 327        read_basic_state
 328        run_specific_rebase
 329        ;;
 330abort)
 331        git rerere clear
 332        read_basic_state
 333        case "$head_name" in
 334        refs/*)
 335                git symbolic-ref HEAD $head_name ||
 336                die "Could not move back to $head_name"
 337                ;;
 338        esac
 339        output git reset --hard $orig_head
 340        rm -r "$state_dir"
 341        exit
 342        ;;
 343esac
 344
 345# Make sure no rebase is in progress
 346if test -n "$in_progress"
 347then
 348        die '
 349It seems that there is already a '"${state_dir##*/}"' directory, and
 350I wonder if you are in the middle of another rebase.  If that is the
 351case, please try
 352        git rebase (--continue | --abort | --skip)
 353If that is not the case, please
 354        rm -fr '"$state_dir"'
 355and run me again.  I am stopping in case you still have something
 356valuable there.'
 357fi
 358
 359if test -n "$interactive_rebase"
 360then
 361        type=interactive
 362        state_dir="$merge_dir"
 363elif test -n "$do_merge"
 364then
 365        type=merge
 366        state_dir="$merge_dir"
 367else
 368        type=am
 369        state_dir="$apply_dir"
 370fi
 371
 372if test -z "$rebase_root"
 373then
 374        case "$#" in
 375        0)
 376                if ! upstream_name=$(git rev-parse --symbolic-full-name \
 377                        --verify -q @{upstream} 2>/dev/null)
 378                then
 379                        . git-parse-remote
 380                        error_on_missing_default_upstream "rebase" "rebase" \
 381                                "against" "git rebase <upstream branch>"
 382                fi
 383                ;;
 384        *)      upstream_name="$1"
 385                shift
 386                ;;
 387        esac
 388        upstream=`git rev-parse --verify "${upstream_name}^0"` ||
 389        die "invalid upstream $upstream_name"
 390        upstream_arg="$upstream_name"
 391else
 392        test -z "$onto" && die "You must specify --onto when using --root"
 393        unset upstream_name
 394        unset upstream
 395        upstream_arg=--root
 396fi
 397
 398# Make sure the branch to rebase onto is valid.
 399onto_name=${onto-"$upstream_name"}
 400case "$onto_name" in
 401*...*)
 402        if      left=${onto_name%...*} right=${onto_name#*...} &&
 403                onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
 404        then
 405                case "$onto" in
 406                ?*"$LF"?*)
 407                        die "$onto_name: there are more than one merge bases"
 408                        ;;
 409                '')
 410                        die "$onto_name: there is no merge base"
 411                        ;;
 412                esac
 413        else
 414                die "$onto_name: there is no merge base"
 415        fi
 416        ;;
 417*)
 418        onto=$(git rev-parse --verify "${onto_name}^0") ||
 419        die "Does not point to a valid commit: $1"
 420        ;;
 421esac
 422
 423# If the branch to rebase is given, that is the branch we will rebase
 424# $branch_name -- branch being rebased, or HEAD (already detached)
 425# $orig_head -- commit object name of tip of the branch before rebasing
 426# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 427switch_to=
 428case "$#" in
 4291)
 430        # Is it "rebase other $branchname" or "rebase other $commit"?
 431        branch_name="$1"
 432        switch_to="$1"
 433
 434        if git show-ref --verify --quiet -- "refs/heads/$1" &&
 435           orig_head=$(git rev-parse -q --verify "refs/heads/$1")
 436        then
 437                head_name="refs/heads/$1"
 438        elif orig_head=$(git rev-parse -q --verify "$1")
 439        then
 440                head_name="detached HEAD"
 441        else
 442                echo >&2 "fatal: no such branch: $1"
 443                usage
 444        fi
 445        ;;
 446*)
 447        # Do not need to switch branches, we are already on it.
 448        if branch_name=`git symbolic-ref -q HEAD`
 449        then
 450                head_name=$branch_name
 451                branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
 452        else
 453                head_name="detached HEAD"
 454                branch_name=HEAD ;# detached
 455        fi
 456        orig_head=$(git rev-parse --verify "${branch_name}^0") || exit
 457        ;;
 458esac
 459
 460require_clean_work_tree "rebase" "Please commit or stash them."
 461
 462# Now we are rebasing commits $upstream..$orig_head (or with --root,
 463# everything leading up to $orig_head) on top of $onto
 464
 465# Check if we are already based on $onto with linear history,
 466# but this should be done only when upstream and onto are the same
 467# and if this is not an interactive rebase.
 468mb=$(git merge-base "$onto" "$orig_head")
 469if test "$type" != interactive && test "$upstream" = "$onto" &&
 470        test "$mb" = "$onto" &&
 471        # linear history?
 472        ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
 473then
 474        if test -z "$force_rebase"
 475        then
 476                # Lazily switch to the target branch if needed...
 477                test -z "$switch_to" || git checkout "$switch_to" --
 478                say "Current branch $branch_name is up to date."
 479                exit 0
 480        else
 481                say "Current branch $branch_name is up to date, rebase forced."
 482        fi
 483fi
 484
 485# If a hook exists, give it a chance to interrupt
 486run_pre_rebase_hook "$upstream_arg" "$@"
 487
 488if test -n "$diffstat"
 489then
 490        if test -n "$verbose"
 491        then
 492                echo "Changes from $mb to $onto:"
 493        fi
 494        # We want color (if set), but no pager
 495        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 496fi
 497
 498test "$type" = interactive && run_specific_rebase
 499
 500# Detach HEAD and reset the tree
 501say "First, rewinding head to replay your work on top of it..."
 502git checkout -q "$onto^0" || die "could not detach HEAD"
 503git update-ref ORIG_HEAD $orig_head
 504
 505# If the $onto is a proper descendant of the tip of the branch, then
 506# we just fast-forwarded.
 507if test "$mb" = "$orig_head"
 508then
 509        say "Fast-forwarded $branch_name to $onto_name."
 510        move_to_original_branch
 511        exit 0
 512fi
 513
 514if test -n "$rebase_root"
 515then
 516        revisions="$onto..$orig_head"
 517else
 518        revisions="$upstream..$orig_head"
 519fi
 520
 521run_specific_rebase